PGSQL_CONTROL
-- $Id: cmp_array.m4,v 1.4 2006/05/17 22:44:58 babolo Exp $
CREATE OR REPLACE FUNCTION array0(anyelement) RETURNS anyarray
 AS 'DECLARE a $0%TYPE:=''{}'';
     BEGIN
        a[0] := $1;
        RETURN a;
     END;
    '
 LANGUAGE PLPGSQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION array0(anyelement)               IS '    [0] ';

CREATE OR REPLACE FUNCTION compare(integer, text[], text[]) RETURNS bool
 AS 'SELECT CASE WHEN $1 IS NULL
                 THEN FALSE
                 WHEN $2 IS NULL AND $3 IS NULL
                 THEN TRUE
                 WHEN $2 IS NULL OR $3 IS NULL
                 THEN FALSE
                 WHEN array_lower($2, 1) <> array_lower($3, 1)
                   OR (   array_upper($2, 1) <> array_upper($3, 1)
                      AND (array_upper($2, 1) < $1 OR array_upper($3, 1) < $1)
                      )
                 THEN FALSE
                 WHEN array_lower($2, 1) > $1
                 THEN TRUE
                 WHEN array_upper($2, 1) > $1
                 THEN $2[array_lower($2, 1):$1] = $3[array_lower($3, 1):$1]
                 ELSE $2 = $3
            END
    '
 LANGUAGE SQL IMMUTABLE
;
COMMENT ON FUNCTION compare(integer, text[], text[]) IS '  $1   $2  $3';

CREATE OR REPLACE FUNCTION cmpstrarrlt(text[], text[]) RETURNS bool
 AS 'DECLARE loopn integer := 1;
             result bool := FALSE;
     BEGIN
         LOOP
             IF $1[loopn] IS NULL AND $2[loopn] IS NULL THEN EXIT; END IF;
             IF $1[loopn] <> $2[loopn]
             THEN result := ($1[loopn] < $2[loopn]); EXIT;
             END IF;
             loopn := loopn + 1;
         END LOOP;
         RETURN result;
     END;
    '
 LANGUAGE PLPGSQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION cmpstrarrlt(text[], text[])      IS '  <   ';

CREATE OR REPLACE FUNCTION cmpstrarrgt(text[], text[]) RETURNS bool
 AS 'SELECT cmpstrarrlt($2, $1)'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION cmpstrarrgt(text[], text[])      IS '  >   ';

CREATE OR REPLACE FUNCTION cmpstrarrge(text[], text[]) RETURNS bool
 AS 'SELECT NOT cmpstrarrlt($1, $2)'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION cmpstrarrge(text[], text[])      IS '  >=   ';

CREATE OR REPLACE FUNCTION cmpstrarrle(text[], text[]) RETURNS bool
 AS 'SELECT NOT cmpstrarrlt($2, $1)'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION cmpstrarrle(text[], text[])      IS '  <=   ';

CREATE OPERATOR <
     ( LEFTARG = text[]
     , RIGHTARG = text[]
     , PROCEDURE = cmpstrarrlt
     , COMMUTATOR = >
     , NEGATOR = >=
     )
;
CREATE OPERATOR >
     ( LEFTARG = text[]
     , RIGHTARG = text[]
     , PROCEDURE = cmpstrarrgt
     , COMMUTATOR = <
     , NEGATOR = <=
     )
;
CREATE OPERATOR >=
     ( LEFTARG = text[]
     , RIGHTARG = text[]
     , PROCEDURE = cmpstrarrge
     , COMMUTATOR = <=
     , NEGATOR = <
     )
;
CREATE OPERATOR <=
     ( LEFTARG = text[]
     , RIGHTARG = text[]
     , PROCEDURE = cmpstrarrle
     , COMMUTATOR = >=
     , NEGATOR = >
     )
;
